<?php 

   # hawk.php
   # License: GPL
   # Written by Greg Heim <gregheim@mindspring.com>

   # read config file
   include ("/usr/local/etc/hawk/php.conf");

   # map these variables
   $sortby=$HTTP_POST_VARS["sortby"];
   $network=$HTTP_POST_VARS["network"];
   $for_rev_check=$HTTP_POST_VARS["for_rev_check"];
   $showeverydamnthing=$HTTP_POST_VARS["showeverydamnthing"];

   $sortoptions = array (
      "IP Address" => "ip",
      "Host Name" => "hostname",
      "Last Ping" => "lastping"
   );

   printheader();

   print "<form method=post>";

   print "<table>\n";

   # unimplemented (need to add code to deterimine if a host is in a given netblock
   print "<tr><td>Network &nbsp;&nbsp;</td><td>";

   dropdown("network", $networks, $network);
   print "</td><td></td></tr>\n";

   print "<tr><td>Sort by</td><td>";
   dropdown("sortby", $sortoptions, $sortby);
   print "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
   submit("Go");
   print "</tr>\n";

   print "</table>\n";

   print "<br>";

   if ($for_rev_check || ($for_rev_check_default && !$network)) {
      $checked = "checked";
   }
   else {
      $checked = "";
   }
   checkbox("for_rev_check", $checked);
   print "&nbsp;&nbsp;<font size=-1>Indicate if the forward and reverse hostnames match.</font>";
   print "<br>";

   if ($showeverydamnthing) {
      $checked = "checked";
   }
   else {
      $checked = "";
   }
   checkbox("showeverydamnthing", $checked);
   print "&nbsp;&nbsp;<font size=-1>Show records with no DNS entry and no ping response.</font>";
   print "<br>";

   print "</form>";

#   href("#key", "Key");

   # show everything until network selection is implemented
   if ($network) {
      shownet ($network);
   }

   anchor("key");
   print "<br>\n";
   showkey();
   printfooter();
   exit;


   #####################################################
   # show status of hosts on this network
   #####################################################
   function shownet ($network) {

      global $dbuser, $dbpass, $dbhost, $dbname, $redzone, $yellowzone, $sortby, $for_rev_check, $showeverydamnthing, $purple_string;
      if (!$link=@mysql_connect($dbhost, $dbuser, $dbpass)) {
         $errormsg = mysql_error();
         print urlencode($errormsg);
         printfooter();
         exit();
      }

      if (!@mysql_select_db($dbname)) {
         $errormsg = mysql_error();
         print urlencode($errormsg);
         printfooter();
         exit();
      }

# select them all for now
      if ($sortby == ip) {
         $query = "select ip, hostname, lastping, for_rev_match from hawk.ip order by inet_aton(ip)";
      }
      else {
         $query = "select ip, hostname, lastping, for_rev_match from hawk.ip order by '$sortby'";
      }
         
      if (!$result = @mysql_query($query)) {
         $errormsg = mysql_error();
         print($errormsg);
         printfooter();
         exit();
      }

      # start the table
      print "<table cellpadding=3 border=2>";
      # table header
      print "<tr><td></td><td>IP</td><td>Hostname</td><td>Last Ping</td></tr>";

      while ($record = mysql_fetch_array($result)) {

         extract ($record);

         # only show blank ping/hostname records if $showeverydamnthing is set
         if ((!$hostname || strstr($hostname, $purple_string)) && !$lastping && !$showeverydamnthing) continue 1;

if (!testip($network, $ip)) continue 1;

         # format the date
         if ($lastping) {
            $date = date("M j G:i:s T Y", $lastping);
         }
         else {
            $date = "Never";
         }


         print "<tr>";

         # no hostname, no ping response
         if ((!$hostname || strstr($hostname, $purple_string)) && !$lastping) {
            print "<td>";img("images/purplesphere.png", 20, 20, "purple");print "</td>";
         }
         # ping response, but no hostname
         elseif ($lastping > (time() - $redzone) && !$hostname) {
            print "<td>";img("images/bluesphere.png", 20, 20, "blue");print "</td>";
         }
         # forward and reverse hostnames do not match
         elseif ($for_rev_check && !$for_rev_match) {
            print "<td>";img("images/questionsphere.png", 20, 20, "question");print "</td>";
         }
         # ping response in "red zone"
         elseif ((time() - $redzone) > $lastping) {
            print "<td>";img("images/redsphere.png", 20, 20, "red");print "</td>";
         }
         # ping response in "yellow zone"
         elseif ((time() - $yellowzone) > $lastping) {
            print "<td>";img("images/yellowsphere.png", 20, 20, "yellow");print "</td>";
         }
         # recent ping response, hostname ok
         else {
            print "<td>";img("images/greensphere.png", 20, 20, "green");print "</td>";
         }
         print "<td>$ip</td>";
         print "<td>$hostname&nbsp;</td>";
         print "<td>$date</td>";
         print "</tr>\n";
      }
      print "</table>";
   }



   #####################################################
   # show the color key
   #####################################################
   function showkey () {

      global $for_rev_check, $yellowzone, $redzone;

      print "<table>\n";

      print "<tr><td>Key:&nbsp;&nbsp;</td><td>";
      img("images/greensphere.png", 10, 10, "green");
      print " Host in DNS.  Recent ping response.<td></tr>";

      if ($for_rev_check) {
         print "<tr><td></td><td>";
         img("images/questionsphere.png", 10, 10, "question");
         print " Host in DNS.  Forward and reverse hostnames do not match.</td></tr>\n";
      }

      print "<tr><td></td><td>";
      img("images/yellowsphere.png", 10, 10, "yellow");
      print " Host in DNS.  No ping response for over $yellowzone seconds.</td></tr>\n";

      print "<tr><td></td><td>";
      img("images/redsphere.png", 10, 10, "red");
      print " Host in DNS.  No ping response for over $redzone seconds.</td></tr>\n";

      print "<tr><td></td><td>";
      img("images/purplesphere.png", 10, 10, "purple");
      print " Host not in DNS.  No ping response.</td></tr>\n";

      print "<tr><td></td><td>";
      img("images/bluesphere.png", 10, 10, "blue");
      print " Host not in DNS.  Recent ping response.</td></tr>\n";

      print "</table>";
   }


   #####################################################
   # print the header
   #####################################################
   function printheader () {
      ?>
         <html>
         <head>
         <link rel="stylesheet" type="text/css" href="hawk.css" title="Hawk Style Sheet">
         <link rel="icon" type="image/vnd.microsoft.icon" href="images/favicon.ico">
         <link rel="shortcut icon" href="images/favicon.ico" />
         <title></title>
         </head>
         <body>
         <blockquote><blockquote><blockquote>
         <table>
         <tr>
            <td>&nbsp;&nbsp;&nbsp;<img src="images/hawk.jpg" height=40 width=40></td>
            <td><h1>Hawk</h1></td>
         </tr>
         <tr>
            <td colspan=2 width=100% nowrap><h2>IP Address Usage Tracking</h2></td>
         </tr>
         </table>
         </blockquote></blockquote></blockquote>
         <br>

      <?php
   }


   #####################################################
   # print the footer
   #####################################################
   function printfooter () {
      ?>
         <hr>
      <?php
   }

   #####################################################
   # silly html functions
   #####################################################
   function dropdown ($fieldName, $selectionArray, $default="") {

      print "<select name=$fieldName>\n";
      while (list ($key, $val) = each ($selectionArray)) {
         $selected = ($val == $default ? " selected " : "");
         print "<option $selected value=$val>$key\n";
      }
      print "</select>\n";
   }

   function submit ($value) {

      print "<input type=submit value='$value'>\n";

   }

   function img ($image, $height="", $width="", $text="") {

      print "<img src=$image height=$height width=$width title=$text alt=$text>";

   }

   function anchor($name) {

      print "<a name='$name'>";

   }

   function href($link, $text) {

      print "<a href='$link'>$text</a>";

   }


   function checkbox($name, $checked="") {

      print "<input type=checkbox name=$name value='On' $checked>";

   }


   #####################################################
   # match ip address (grabbed from php.net)
   #####################################################
   function testip($range,$ip) {

      $result = 1;

      # IP Pattern Matcher
      # J.Adams <jna@retina.net>
      #
      # Matches:
      #
      # xxx.xxx.xxx.xxx        (exact)
      # xxx.xxx.xxx.[yyy-zzz]  (range)
      # xxx.xxx.xxx.xxx/nn     (nn = # bits, cisco style -- i.e. /24 = class C)
      #
      # Does not match:
      # xxx.xxx.xxx.xx[yyy-zzz]  (range, partial octets not supported)

      if (ereg("([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)/([0-9]+)",$range,$regs)) {

         # perform a mask match
         $ipl = ip2long($ip);
         $rangel = ip2long($regs[1] . "." . $regs[2] . "." . $regs[3] . "." . $regs[4]);
         $maskl = 0;

         for ($i = 0; $i< 31; $i++) {
            if ($i < $regs[5]-1) {
               $maskl = $maskl + pow(2,(30-$i));
            }
         }
         if (($maskl & $rangel) == ($maskl & $ipl)) {
            return 1;
         }
         else {
            return 0;
         }
      }
      else {
         # range based
         $maskocts = split("\.",$range);
         $ipocts = split("\.",$ip);

         # perform a range match
         for ($i=0; $i<4; $i++) {
            if (ereg("\[([0-9]+)\-([0-9]+)\]",$maskocts[$i],$regs)) {
               if ( ($ipocts[$i] > $regs[2]) || ($ipocts[$i] < $regs[1])) {
                  $result = 0;
               }
            }
            else {
               if ($maskocts[$i] <> $ipocts[$i]) {
                  $result = 0;
               }
            }
         }
      }
      return $result;
   }

?>
